// "scripts": [
//     "background.js"
// ],

var parent = chrome.contextMenus.create({ "title": "Add to MasterCook", "contexts": ["selection", "image"] });  //Menu Id : 1
var titleText = '';

titleText = 'Author';
if (localStorage.getItem("MC_Author") != null && localStorage.getItem("MC_Author") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToAuthor });  //Menu Id : 2


titleText = "Cook Time";
if (localStorage.getItem("MC_CookTime") != null && localStorage.getItem("MC_CookTime") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToCookTime });  //Menu Id : 3

titleText = "Copyright";
if (localStorage.getItem("MC_Copyright") != null && localStorage.getItem("MC_Copyright") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToCopyright });  //Menu Id : 4

titleText = "Description";
if (localStorage.getItem("MC_Description") != null && localStorage.getItem("MC_Description") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToDescription });  //Menu Id : 5

titleText = "Image Url";
if (localStorage.getItem("MC_ImageUri") != null && localStorage.getItem("MC_ImageUri") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["image"], "parentId": parent, "onclick": addToImageUri });  //Menu Id : 6

titleText = "Ingredients";
if (localStorage.getItem("MC_Ingredients") != null && localStorage.getItem("MC_Ingredients") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToIngredients });  //Menu Id : 7

titleText = "Instructions";
if (localStorage.getItem("MC_Instructions") != null && localStorage.getItem("MC_Instructions") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToInstructions });  //Menu Id : 8

titleText = "Notes";
if (localStorage.getItem("MC_Notes") != null && localStorage.getItem("MC_Notes") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToNotes });  //Menu Id : 9

titleText = "Preparation Time";
if (localStorage.getItem("MC_PrepTime") != null && localStorage.getItem("MC_PrepTime") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToPrepTime });  //Menu Id : 10

titleText = "Servings";
if (localStorage.getItem("MC_Servings") != null && localStorage.getItem("MC_Servings") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToServings });  //Menu Id : 11

titleText = "Serving Ideas";
if (localStorage.getItem("MC_ServingIdeas") != null && localStorage.getItem("MC_ServingIdeas") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToServingIdeas });  //Menu Id : 12

titleText = "Source";
if (localStorage.getItem("MC_Source") != null && localStorage.getItem("MC_Source") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToSource });  //Menu Id : 13


titleText = "Title";
if (localStorage.getItem("MC_Title") != null && localStorage.getItem("MC_Title") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToTitle });  //Menu Id : 14  

titleText = "Total Time";
if (localStorage.getItem("MC_TotalTime") != null && localStorage.getItem("MC_TotalTime") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToTotalTime });  //Menu Id : 15

titleText = "Wine";
if (localStorage.getItem("MC_Wine") != null && localStorage.getItem("MC_Wine") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToWine });  //Menu Id : 16

titleText = "Yield";
if (localStorage.getItem("MC_Yield") != null && localStorage.getItem("MC_Yield") != '') { titleText = titleText + "  ✔️"; }
chrome.contextMenus.create({ "title": titleText, "contexts": ["selection"], "parentId": parent, "onclick": addToYield });  //Menu Id : 17


// if (navigator.userAgent.indexOf("Firefox") != -1) {
//   chrome.contextMenus.create({ "title": "Launch Master Cook", "command":"_execute_browser_action", "contexts": ["page","selection","link","editable","image","video"] }); 
// }

// chrome.contextMenus.onClicked.addListener(getword)
// function getword(info,tab,$event){


// }


function addToTitle(info, tab) {
  localStorage.setItem("MC_Title", info.selectionText);
  if (info.selectionText != '') {
    // chrome.contextMenus.update(info.menuItemId, { "title": "Title  [Added..]" });
    chrome.contextMenus.update(info.menuItemId, { "title": "Title  ✔️" });
  }
}
function addToServings(info, tab) {
  localStorage.setItem("MC_Servings", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Servings  ✔️" });
  }
}
function addToYield(info, tab) {
  localStorage.setItem("MC_Yield", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Yield  ✔️" });
  }
}
function addToIngredients(info, tab) {
  // localStorage.setItem("MC_Ingredients", info.selectionText);
  // if (info.selectionText != '') {
  //   chrome.contextMenus.update(info.menuItemId, { "title": "Ingredients  ✔️" });
  // }
  chrome.tabs.query({ 'active': true, 'windowId': chrome.windows.WINDOW_ID_CURRENT },
    tabs => {
      let code = `document.execCommand("copy")`;
      chrome.tabs.executeScript(tabs[0].id, { code }, result => {
        var cText = getClipboard();
        localStorage.setItem("MC_Ingredients", cText);
        if (cText != '') {
          chrome.contextMenus.update(info.menuItemId, { "title": "Ingredients  ✔️" });
        }
      });
    }
  )
}
function addToInstructions(info, tab) {
  // localStorage.setItem("MC_Instructions", info.selectionText);
  // if (info.selectionText != '') {
  //   chrome.contextMenus.update(info.menuItemId, { "title": "Instructions  ✔️" });
  // }

  chrome.tabs.query({ 'active': true, 'windowId': chrome.windows.WINDOW_ID_CURRENT },
    tabs => {
      let code = `document.execCommand("copy")`;
      chrome.tabs.executeScript(tabs[0].id, { code }, result => {
        var cText = getClipboard();
        localStorage.setItem("MC_Instructions", cText);
        if (cText != '') {
          chrome.contextMenus.update(info.menuItemId, { "title": "Instructions  ✔️" });
        }
      });
    }
  )

  // chrome.tabs.active({ 'active': true, 'windowId': chrome.windows.WINDOW_ID_CURRENT },
  //   tabs => {
  //     let code = `document.execCommand("copy")`;
  //     chrome.tabs.executeScript(tabs[0].id, { code }, result => {
  //       var cText = getClipboard();
  //       localStorage.setItem("MC_Instructions", cText);
  //       if (cText != '') {
  //         chrome.contextMenus.update(info.menuItemId, { "title": "Instructions  ✔️" });
  //       }
  //     });
  //   }
  // )
}
function addToImageUri(info, tab) {
  localStorage.setItem("MC_ImageUri", info.srcUrl);
  if (info.srcUrl != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Image Url  ✔️" });
  }
}
function addToSource(info, tab) {
  localStorage.setItem("MC_Source", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Source  ✔️" });
  }
}
function addToCopyright(info, tab) {
  localStorage.setItem("MC_Copyright", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Copyright  ✔️" });
  }
}
function addToAuthor(info, tab) {
  localStorage.setItem("MC_Author", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Author  ✔️" });
  }
}
function addToPrepTime(info, tab) {
  localStorage.setItem("MC_PrepTime", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Preparation Time  ✔️" });
  }
}
function addToCookTime(info, tab) {
  localStorage.setItem("MC_CookTime", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Cook Time  ✔️" });
  }
}
function addToTotalTime(info, tab) {
  localStorage.setItem("MC_TotalTime", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Total Time  ✔️" });
  }
}
function addToDescription(info, tab) {
  localStorage.setItem("MC_Description", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Description  ✔️" });
  }
}
function addToServingIdeas(info, tab) {
  localStorage.setItem("MC_ServingIdeas", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Serving Ideas  ✔️" });
  }
}
function addToNotes(info, tab) {
  localStorage.setItem("MC_Notes", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Notes  ✔️" });
  }
}
function addToWine(info, tab) {
  localStorage.setItem("MC_Wine", info.selectionText);
  if (info.selectionText != '') {
    chrome.contextMenus.update(info.menuItemId, { "title": "Wine  ✔️" });
  }
}
// CATEGORIZED CONTEXT MENU NEW FORMAT  -- End here


function getClipboard() {
  var result = null;
  var textarea = document.getElementById('ta');
  textarea.value = '';
  textarea.select();

  if (document.execCommand('paste')) {
    result = textarea.value;
  } else {
    console.error('failed to get clipboard content');
  }

  textarea.value = '';
  return result;
}